<?php

namespace dgsoft\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceFeeInfoRQ StructType
 * @package Dg
 * @subpackage Structs
 */
class DgServiceFeeInfoRQ extends DgGenericFlightRQ
{
    /**
     * The FlightInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgServiceFeeInfoRQFlightInfo
     */
    public $FlightInfo;
    /**
     * The HotelInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgServiceFeeInfoRQHotelInfo
     */
    public $HotelInfo;
    /**
     * The CarInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgServiceFeeInfoRQCarInfo
     */
    public $CarInfo;
    /**
     * The InsuranceInfo
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \dgsoft\StructType\DgServiceFeeInfoRQInsuranceInfo
     */
    public $InsuranceInfo;
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * Constructor method for ServiceFeeInfoRQ
     * @uses DgServiceFeeInfoRQ::setFlightInfo()
     * @uses DgServiceFeeInfoRQ::setHotelInfo()
     * @uses DgServiceFeeInfoRQ::setCarInfo()
     * @uses DgServiceFeeInfoRQ::setInsuranceInfo()
     * @uses DgServiceFeeInfoRQ::setType()
     * @param \dgsoft\StructType\DgServiceFeeInfoRQFlightInfo $flightInfo
     * @param \dgsoft\StructType\DgServiceFeeInfoRQHotelInfo $hotelInfo
     * @param \dgsoft\StructType\DgServiceFeeInfoRQCarInfo $carInfo
     * @param \dgsoft\StructType\DgServiceFeeInfoRQInsuranceInfo $insuranceInfo
     * @param string $type
     */
    public function __construct(\dgsoft\StructType\DgServiceFeeInfoRQFlightInfo $flightInfo = null, \dgsoft\StructType\DgServiceFeeInfoRQHotelInfo $hotelInfo = null, \dgsoft\StructType\DgServiceFeeInfoRQCarInfo $carInfo = null, \dgsoft\StructType\DgServiceFeeInfoRQInsuranceInfo $insuranceInfo = null, $type = null)
    {
        $this
            ->setFlightInfo($flightInfo)
            ->setHotelInfo($hotelInfo)
            ->setCarInfo($carInfo)
            ->setInsuranceInfo($insuranceInfo)
            ->setType($type);
    }
    /**
     * Get FlightInfo value
     * @return \dgsoft\StructType\DgServiceFeeInfoRQFlightInfo|null
     */
    public function getFlightInfo()
    {
        return $this->FlightInfo;
    }
    /**
     * Set FlightInfo value
     * @param \dgsoft\StructType\DgServiceFeeInfoRQFlightInfo $flightInfo
     * @return \dgsoft\StructType\DgServiceFeeInfoRQ
     */
    public function setFlightInfo(\dgsoft\StructType\DgServiceFeeInfoRQFlightInfo $flightInfo = null)
    {
        $this->FlightInfo = $flightInfo;
        return $this;
    }
    /**
     * Get HotelInfo value
     * @return \dgsoft\StructType\DgServiceFeeInfoRQHotelInfo|null
     */
    public function getHotelInfo()
    {
        return $this->HotelInfo;
    }
    /**
     * Set HotelInfo value
     * @param \dgsoft\StructType\DgServiceFeeInfoRQHotelInfo $hotelInfo
     * @return \dgsoft\StructType\DgServiceFeeInfoRQ
     */
    public function setHotelInfo(\dgsoft\StructType\DgServiceFeeInfoRQHotelInfo $hotelInfo = null)
    {
        $this->HotelInfo = $hotelInfo;
        return $this;
    }
    /**
     * Get CarInfo value
     * @return \dgsoft\StructType\DgServiceFeeInfoRQCarInfo|null
     */
    public function getCarInfo()
    {
        return $this->CarInfo;
    }
    /**
     * Set CarInfo value
     * @param \dgsoft\StructType\DgServiceFeeInfoRQCarInfo $carInfo
     * @return \dgsoft\StructType\DgServiceFeeInfoRQ
     */
    public function setCarInfo(\dgsoft\StructType\DgServiceFeeInfoRQCarInfo $carInfo = null)
    {
        $this->CarInfo = $carInfo;
        return $this;
    }
    /**
     * Get InsuranceInfo value
     * @return \dgsoft\StructType\DgServiceFeeInfoRQInsuranceInfo|null
     */
    public function getInsuranceInfo()
    {
        return $this->InsuranceInfo;
    }
    /**
     * Set InsuranceInfo value
     * @param \dgsoft\StructType\DgServiceFeeInfoRQInsuranceInfo $insuranceInfo
     * @return \dgsoft\StructType\DgServiceFeeInfoRQ
     */
    public function setInsuranceInfo(\dgsoft\StructType\DgServiceFeeInfoRQInsuranceInfo $insuranceInfo = null)
    {
        $this->InsuranceInfo = $insuranceInfo;
        return $this;
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @param string $type
     * @return \dgsoft\StructType\DgServiceFeeInfoRQ
     */
    public function setType($type = null)
    {
        // validation for constraint: string
        if (!is_null($type) && !is_string($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($type)), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \dgsoft\StructType\DgServiceFeeInfoRQ
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
